using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;


namespace ComboGDBG
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;

		// The the form class:
		private ToolTipExtGrid.GridTextExtender m_oGridTextExtender = null;
		

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 24);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(664, 448);
			this.gridGroupingControl1.TabIndex = 1;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.401.0.49";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(704, 478);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		
		private void Form1_Load(object sender, System.EventArgs e)
		{
			
			Hashtable table = new Hashtable();
           
			DataTable dt = GetParentTable();
			
			this.gridGroupingControl1.DataSource = dt; 

			m_oGridTextExtender = new ToolTipExtGrid.GridTextExtender(this);
			m_oGridTextExtender.ShowHeaderToolTip = true;
			
			for(int i = 0;i < 5;i++)  
				table.Add(i + 1,"Your Abbreviated ColumnName here..");   
			m_oGridTextExtender.ExtendedHeaderText = table;

			this.gridGroupingControl1.TableControl.MouseMove +=new MouseEventHandler(TableControl_MouseMove);

			this.gridGroupingControl1.TableDescriptor.Columns[0].Width = 20;
			this.gridGroupingControl1.TableDescriptor.Columns[1].Width = 20;
			this.gridGroupingControl1.TableDescriptor.Columns[2].Width = 20;

			this.gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.Trimming =  StringTrimming.EllipsisCharacter;   
		
		}

		#region DataTables

		private int numberParentRows = 12;
		private int numberChildRows = 20;
		
		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("EmpNo"));
			dt.Columns.Add(new DataColumn("EmpName" ));
			dt.Columns.Add(new DataColumn("DeptNo"));
			dt.Columns.Add(new DataColumn("Salary" ,typeof(int)));

			for(int i = 0;i< 5;i++)
			dt.Columns.Add(new DataColumn("Column" + i));
			
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = "EmployeeNumber" + i; 
				dr[1] = "EmpName" + i; 
				dr[2] = "DeptNo" + i; 
				dr[3] = 1000 * 10 * i; 
				dt.Rows.Add(dr);
			}
		 


			return dt;
		}

				
		#endregion

		

		
		private void TableControl_MouseMove(object sender, MouseEventArgs e)
		{
			m_oGridTextExtender.Show( (sender as GridTableControl) , new Point(e.X, e.Y));
		}
	}
}
